package query

import (
	"encoding/json"
	"github.com/odysseus/service-registry/common"
	"github.com/redis/go-redis/v9"
)

type NodeManagerInfo struct {
	Timestamp int64  `redis:"timestamp" json:"timestamp"`
	Endpoint  string `redis:"endpoint" json:"endpoint"`
}

func (g NodeManagerInfo) TimeStamp() int64 {
	return g.Timestamp
}

func (g NodeManagerInfo) Message() json.RawMessage {
	d, _ := json.Marshal(g)
	return d
}

func (g NodeManagerInfo) Parse(res *redis.MapStringStringCmd) ServiceInfo {
	var info NodeManagerInfo
	if err := res.Scan(&info); err != nil {
		return nil
	}
	return info
}

type nodeManagerQuery struct {
	baseService
}

func getNodeManagerQuery(rdb *redis.Client) ServiceQuery {
	return nodeManagerQuery{
		baseService{
			rdb:     rdb,
			service: common.SERVICE_NODE_MANAGER,
		},
	}
}
