package query

import (
	"encoding/json"
	"github.com/odysseus/service-registry/common"
	"github.com/redis/go-redis/v9"
)

type SchedulerInfo struct {
	Timestamp int64  `redis:"timestamp" json:"timestamp"`
	Endpoint  string `redis:"endpoint" json:"endpoint"`
}

func (g SchedulerInfo) TimeStamp() int64 {
	return g.Timestamp
}

func (g SchedulerInfo) Message() json.RawMessage {
	d, _ := json.Marshal(g)
	return d
}

func (g SchedulerInfo) Parse(res *redis.MapStringStringCmd) ServiceInfo {
	var info SchedulerInfo
	if err := res.Scan(&info); err != nil {
		return nil
	}
	return info
}

type schedulerQuery struct {
	baseService
}

func getSchedulerQuery(rdb *redis.Client) ServiceQuery {
	return schedulerQuery{
		baseService{
			rdb:     rdb,
			service: common.SERVICE_SCHEDULER,
		},
	}
}
